package android.drawing;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnTouchListener;

/*
 * Rajzols sajt View felleten.
 *  
 * */

public class Rajzpapir extends View implements OnTouchListener {
	
	Context context;	
	byte ujjak_szama;
	
	// Ujjak gyjtje, 5db rints tmogatsa
	final static Ujj[] ujjak = {
			new Ujj(0, 0, 50, Color.YELLOW),
			new Ujj(0, 0, 50, Color.GREEN),
			new Ujj(0, 0, 50, Color.CYAN), 
			new Ujj(0, 0, 50, Color.RED),
			new Ujj(0, 0, 50, Color.WHITE)
	};
	
	// Rajzols kellkei
	static Paint circlePaint = new Paint();
	static Paint subCirclePaint = new Paint();
	static Paint crossPaint = new Paint();
	
	// Konstruktor
	public Rajzpapir(Context context) {
		super(context);
		this.context = context;		
		this.setOnTouchListener(this);
	}

	@Override
	protected void onDraw(Canvas canvas) {
		super.onDraw(canvas);
		
		canvas.save();		
		for (Ujj f : ujjak) {
			// Ha ki kell rajzolni
			if(f.isShow()){
				// Tengelyek rajzolsa				
				crossPaint.setColor(Color.GRAY);
				crossPaint.setStrokeWidth(2);				
				canvas.drawLine(0, f.getY(), canvas.getWidth(), f.getY(), crossPaint);	// horizontal
				canvas.drawLine(f.getX(), 0, f.getX(), canvas.getHeight(), crossPaint); // vertical
				
				// Kr rajzolsa				
				circlePaint.setColor(f.getColor());
				circlePaint.setAntiAlias(true);		
				subCirclePaint.setColor(Color.BLACK);
				subCirclePaint.setAntiAlias(true);
				canvas.drawCircle(f.getX(),	f.getY(), f.getR(), circlePaint);
				canvas.drawCircle(f.getX(), f.getY(), f.getR() - 10, subCirclePaint); // fekete kr				
			}
		}		
		canvas.restore();		
	}

	@Override
	public boolean onTouch(View v, MotionEvent event) {
		
		// Szk keresztmetszet keresse, amelyik kisebb: 
		// rints szm vagy max ujj tmogats
		ujjak_szama = (byte)Math.min(ujjak.length, event.getPointerCount());
		
		// ppen mozgsban van
		if(event.getAction() == MotionEvent.ACTION_MOVE){
			for(byte i = 0; i < ujjak_szama; i++){	
				ujjak[i].setX((int)event.getX(i));
				ujjak[i].setY((int)event.getY(i));
				ujjak[i].setShow(true);
			}			
		}
		
		// Felemeltk a keznket
		if(event.getAction() == MotionEvent.ACTION_UP)
			for(byte i = 0; i < ujjak.length; i++)
				ujjak[i].setShow(false);
		
		// Rajzols frisstse
		invalidate();
		
		return true;
	}
	
	

}
